#define echoPin 7 // attach pin D2 Arduino to pin Echo of HC-SR04 
#define trigPin 6 //attach pin D3 Arduino to pin Trig of HC-SR04
#define MotorPin 11 //Pin to attach NMOS to control motor
#include "Adafruit_Keypad.h"//including Keypad library
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include "RTClib.h"

LiquidCrystal_I2C lcd(0x27, 16, 2); //A4 to SDA and A5 to SCL
RTC_DS3231 rtc;

unsigned long State3Timer;
int variable = 33;
// defines variables
long duration; // variable for the duration of sound wave travel
float distance; // variable for the distance measurement
float threshold;

int nowyear = 2021;
int nowmonth = 05;
int nowday = 06;

int birthdayYear;
int birthdayMonth;
int birthdayDay;

int thresholdAge = 21;

byte State = 1; //declaring state equal to one

unsigned long State4Timer = 0;
unsigned long State5Timer = 0;

int x = 16;
//unsigned long previousMillis = 0;
//const long interval = 350;

unsigned long changeTime = 0;

char prevButton; //store previous button value

//deinfing keypad variables
const byte ROWS = 4; // rows
const byte COLS = 4; // columns
//define the symbols on the buttons of the keypads
char keys[ROWS][COLS] = {
  {1, 2, 3, 'A'},
  {4, 5, 6, 'B'},
  {7, 8, 9, 'C'},
  {'*', 0, '#', 'D'}
};
byte rowPins[ROWS] = {12, 10, 9, 8}; //connect to the row pinouts of the keypad
byte colPins[COLS] = {5, 4, 3, 2}; //connect to the column pinouts of the keypad

byte i = 0;// number pad incrementor declared

int birthdayInput[9]; //Aray holds nine numbers for birthday and # storage

//initialize an instance of class NewKeypad
Adafruit_Keypad customKeypad = Adafruit_Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS);

void setup() {
  rtc.adjust(DateTime(2021, 05, 06, 0, 0, 0));
  lcd.init(); //set  up for LCD
  lcd.backlight();

  pinMode(trigPin, OUTPUT); // Sets the trigPin as an OUTPUT
  pinMode(echoPin, INPUT); // Sets the echoPin as an INPUT

  pinMode(MotorPin, OUTPUT); //Sets motorpin as output

  customKeypad.begin();//initializes key pad library

  Serial.begin(9600); // // Serial Communication is starting with 9600 of baudrate speed
  //  Serial.println("Ultrasonic Sensor HC-SR04 Test"); // print some text in Serial Monitor
  //  Serial.println("with Arduino UNO R3");
}

bool ageCheck() {
 

  if (nowyear - birthdayYear > thresholdAge) { //if today (in unix years) - birthday (in unix years) >= 21
    //Serial.println( " Year Congratulations you're old!!");
    return HIGH;
  }
  else if (nowyear - birthdayYear < thresholdAge) {
    
    return LOW;
  }
  else if ( nowyear - birthdayYear == thresholdAge) {
    if (nowmonth > birthdayMonth) {
      
      return HIGH;
    }
    else if (nowmonth < birthdayMonth) {
      
      return LOW;
    }
    else if (nowmonth == birthdayMonth) {
      if (nowday > birthdayDay) {
        
        return HIGH;
      }
      else if (nowday == birthdayDay) {
       
        return HIGH;
      }
      else {
        
        return LOW;
      }
    }
  }
}

void levelCheck() {
  // Clears the trigPin condition
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin HIGH (ACTIVE) for 10 microseconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  // Calculating the distance
  distance = duration * 0.034 / 2; // Speed of sound wave divided by 2 (go and back)
}
void displayLevel() {
  //Serial.print("Distance: "); //Displays actual distance from liquid
  //Serial.print(distance); //use this to program to determine thresholds
}
void buttonCheck() {
  //Keypad main run code
  customKeypad.tick();//has key been pressed

  while (customKeypad.available()) {
    keypadEvent e = customKeypad.read();

    if (e.bit.EVENT == KEY_JUST_PRESSED) {
      prevButton = (char)e.bit.KEY;
      
      
      if (State == 1) {
        birthdayInput[i] = prevButton;
        i++ ;
      }
    }
  }
}
void LCDPrint(String printPhrase) {
  //LDC print function
  //  unsigned long currentMillis = millis();
  //  if (currentMillis - previousMillis >= interval) {
  //    // save the last time you cycled the LCD
  //    previousMillis = currentMillis;
  //    lcd.clear();
  //    if (abs(x) - 1 <= printPhrase.length()) {
  //      x = x - 1;
  //    }
  //    else x = -5;
  //    Serial.print( x); //What is x?
  //
  //    lcd.setCursor(x, 0);
  //    lcd.print(printPhrase);
  //  }
  if (millis() - changeTime > 500) {
    lcd.setCursor(1, 0);
    lcd.print(printPhrase);
    lcd.scrollDisplayLeft();
    changeTime = millis();
  }
}
void loop() {
  buttonCheck();
  levelCheck(); //intiate a level check
  
  
        /*DateTime now =rtc.now();
        
        Serial.print(now.year(), DEC);
        Serial.print('/');
        Serial.print(now.month(), DEC);
        Serial.print('/');
        Serial.print(now.day(), DEC);
        Serial.print(" (");

*/
  switch (State) {
      
    case 1 : //in state one
      Serial.println(distance);
      LCDPrint("Please enter your birthday and press #");

      if (i < 9 && prevButton == '#')
      {
        i = 0;
      }
      else if ( prevButton == '#') {
        
        prevButton = 0;
        lcd.clear();
        State = 2; //go to state two
        i = 0 ;
        break;
      }
      break;

    case 2 : //Birthday info extracted
      birthdayYear = birthdayInput[4] * 1000 + birthdayInput[5] * 100 + birthdayInput[6] * 10 + birthdayInput[7];
     
      birthdayMonth = birthdayInput[0] * 10 + birthdayInput[1];
      
      birthdayDay =  birthdayInput[2] * 10 + birthdayInput[3];
      

      if (ageCheck()) {
        for (int k = 0; k < 9; k ++) {
          birthdayInput[k] = 0;
        }
        State3Timer = millis();
        State = 3;
      }
      else {
      
        for (int k = 0; k < 9; k ++) {
          birthdayInput[k] = 0;
        }
        State = 7;
        State4Timer = millis();
      }

      break;
    case 3:
      LCDPrint("Congratulations you're Old!");
      if (millis() - State3Timer > 2000)
      {
        State = 4;
      }
    case 4 : //Fill level selection code
    LCDPrint( "How full would you like your cup?");
     
      switch (prevButton) {
        case 'A':
        threshold = 16;
        variable = 25;
        lcd.clear();
        State =5;
      break;
        case 'B':
        threshold = 14;
        variable = 50;
        lcd.clear();
        State =5;
      break;
        case 'C':
        threshold = 12;
        variable = 75;
        lcd.clear();
        State =5;
      break;
        case 'D':
        threshold = 10;
        variable = 100;
        lcd.clear();
        State =5;
      break;
        case '*':
        digitalWrite (MotorPin, LOW);
        lcd.clear();
        State = 1;
      default:
      break;
      }   
      break;

    case 5:
    LCDPrint("Pouring Cup to " + String(variable) + "%"); 
   
    
          if (distance < threshold) {
            digitalWrite (MotorPin, LOW);
            //Serial.print(" LOW"); //shows pump off
            State5Timer = millis();
            State =6;
          }  //if desired level, turn pump off
          else {
            digitalWrite (MotorPin, HIGH);
            //Serial.print(" HIGH"); //shows pump on
          } //leave pump on if desired level not met
          displayLevel(); //shows level
          if (prevButton == '*')
          {
            digitalWrite (MotorPin, LOW);
            State =1;
          }
      
      break;

    case 6:
     
      LCDPrint(" Drink Responsibly!");
      if ( millis() - State5Timer > 2000) {
        lcd.clear();
        State = 1;
        break;
      }
      break;
      
    case 7: //LCD displays too young and boots back to beginning
      
      LCDPrint("CHILD ALERT! no drink for you");
      if ( millis() - State4Timer > 2000) {
        lcd.clear();
        State = 1;
        break;
      }
      break;

  }
}
